#include<iostream>
#include<algorithm>
#define INF 1000000000
using namespace std;



int dp[1 << 18][18], n, m, a, b, l;
int conn[18][18];




int main() {
	cin.sync_with_stdio(false);
	
	cin >> n >> m;
	
	fill(conn[0], conn[0] + 18*18, INF);
	
	
	
	for(int i=0;i<m;i++) {
		cin >> a >> b >> l;
		
		a--, b--;
		conn[a][b] = min(conn[a][b], l);
		conn[b][a] = min(conn[b][a], l);
	}
	
	
	fill(dp[0], dp[0] + (1 << 18) * 18, INF);
	dp[1][0] = 0;
	
	//Here we perform the actual dp calculation
	
	for(int comb = 1; comb + 1 < (1 << n); comb++)
		for(int s = 0; s < n; s++) if(dp[comb][s] != INF) {
			
			for(int e=0;e<n;e++)
				if( (comb & (1 << e) ) == 0 ) {
					
					int ncomb = comb + (1 << e);
					
					dp[ncomb][e] = min(dp[ncomb][e], dp[comb][s] + conn[s][e]);
					
				}
			
		}
	
	
	
	
	//Finally find the result
	
	int result = INF;
	
	for(int i=0;i<n;i++)
		result = min(result,  dp[(1 << n) - 1] [i] + conn[i][0] );
	
	
	if(result == INF)
		cout << "-1\n";
	else
		cout << result << '\n';
	
	return 0;
	
}














































